#property indicator_chart_window 

extern int    NumberOfDays = 999;             
extern string AsiaBegin    = "02:00";        
extern string AsiaEnd      = "10:00";        
extern color  AsiaColor    = DarkSeaGreen;    
extern string EurBegin     = "10:00";        
extern string EurEnd       = "15:00";        
extern color  EurColor     = Thistle;         
extern string USABegin     = "15:00";        
extern string USAEnd       = "19:00";        
extern color  USAColor     = BurlyWood;       
extern bool   ShowPrice    = true;           
extern color  clFont       = Teal;           
extern int    SizeFont     = 8;              
extern int    OffSet       = 10;  


int init() 
{   
    DeleteObjects();
    for (int d=0; d<NumberOfDays; d++) 
    {
    CreateObjects("AS"+d, AsiaColor);
    CreateObjects("EU"+d, EurColor);
    CreateObjects("US"+d, USAColor);
    }
           
    return(0); 
} 

void deinit() 
     {
     DeleteObjects();
     Comment("");
     }

void CreateObjects(string no, color cl) 
     {
     ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
     ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
     ObjectSet(no, OBJPROP_COLOR, cl);
     ObjectSet(no, OBJPROP_BACK, True);
     }

void DeleteObjects() 
     {
     for (int d=0; d<NumberOfDays; d++) 
     {
     ObjectDelete("AS"+d);
     ObjectDelete("EU"+d);
     ObjectDelete("US"+d);
     }
     ObjectDelete("ASup");
     ObjectDelete("ASdn");
     ObjectDelete("EUup");
     ObjectDelete("EUdn");
     ObjectDelete("USup");
     ObjectDelete("USdn");
}

int start() 
{ 
         
    int m,s,k;
    m=Time[0]+Period()*60-CurTime();
    s=m%60;
    m=(m-m%60)/60;
    Comment("TIME: ", m, ":", s);
    
  datetime dt=CurTime();
  for (int d=0; d<NumberOfDays; d++) 
  {
    if (ShowPrice && d==0) 
    {
      DrawPrices(dt, "AS", AsiaBegin, AsiaEnd);
      DrawPrices(dt, "EU", EurBegin, EurEnd);
      DrawPrices(dt, "US", USABegin, USAEnd);
    }
    DrawObjects(dt, "AS"+d, AsiaBegin, AsiaEnd);
    DrawObjects(dt, "EU"+d, EurBegin, EurEnd);
    DrawObjects(dt, "US"+d, USABegin, USAEnd);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
}

void DrawObjects(datetime dt, string no, string tb, string te) 
     {
     datetime t1, t2;
     double   p1, p2;
     int      b1, b2;

     t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
     t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
     b1=iBarShift(NULL, 0, t1);
     b2=iBarShift(NULL, 0, t2);
     p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
     p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
     ObjectSet(no, OBJPROP_TIME1 , t1);
     ObjectSet(no, OBJPROP_PRICE1, p1);
     ObjectSet(no, OBJPROP_TIME2 , t2);
     ObjectSet(no, OBJPROP_PRICE2, p2);
}

void DrawPrices(datetime dt, string no, string tb, string te) {
     datetime t1, t2;
     double   p1, p2;
     int      b1, b2;

     t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
     t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
     b1=iBarShift(NULL, 0, t1);
     b2=iBarShift(NULL, 0, t2);
     p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
     p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];

     if (ObjectFind(no+"up")<0) ObjectCreate(no+"up", OBJ_TEXT, 0, 0,0);
     ObjectSet(no+"up", OBJPROP_TIME1   , t2);
     ObjectSet(no+"up", OBJPROP_PRICE1  , p1+OffSet*Point);
     ObjectSet(no+"up", OBJPROP_COLOR   , clFont);
     ObjectSet(no+"up", OBJPROP_FONTSIZE, SizeFont);
     ObjectSetText(no+"up", DoubleToStr(p1+Ask-Bid, Digits));

     if (ObjectFind(no+"dn")<0) ObjectCreate(no+"dn", OBJ_TEXT, 0, 0,0);
     ObjectSet(no+"dn", OBJPROP_TIME1   , t2);
     ObjectSet(no+"dn", OBJPROP_PRICE1  , p2);
     ObjectSet(no+"dn", OBJPROP_COLOR   , clFont);
     ObjectSet(no+"dn", OBJPROP_FONTSIZE, SizeFont);
     ObjectSetText(no+"dn", DoubleToStr(p2, Digits));
}

datetime decDateTradeDay (datetime dt) 
         {
         int ty=TimeYear(dt);
         int tm=TimeMonth(dt);
         int td=TimeDay(dt);
         int th=TimeHour(dt);
         int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
    
}