//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4
#property indicator_color1 White    
#property indicator_color2 MediumBlue
#property indicator_color3 DeepPink
#property indicator_color4 Peru

extern int MAType=0;
extern int MAPeriod=24;
extern bool Automatic_Timeframe_Setting = true;
extern int M1_MAPeriod = 720;
extern int M5_MAPeriod = 144;
extern int M15_MAPeriod = 48;
extern int M30_MAPeriod = 24;
extern int H1_MAPeriod = 12;
extern int H4_MAPeriod = 24;
extern int D1_MAPeriod = 24;

//---- buffers

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double MA_up[],MA_dn[], MA1[];
double buy[], sell[];

//---- variables

int    MAMode;
string strMAType;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(4);
   
//---- drawing settings
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(0,ExtMapBuffer3);
   SetIndexBuffer(3,MA1);
   
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2); 

switch (MAType)
   {
      case 1: strMAType="EMA"; MAMode=MODE_EMA; break;
      case 2: strMAType="SMMA"; MAMode=MODE_SMMA; break;
      case 3: strMAType="LWMA"; MAMode=MODE_LWMA; break;
      case 4: strMAType="LSMA"; break;
      default: strMAType="SMA"; MAMode=MODE_SMA; break;
   }
   //---- initialization done
   return(0);
  }

int start()

  {
  int maperiod, ma1period;
  if (Automatic_Timeframe_Setting == true) {
      switch(Period()) {
         case 1: maperiod = M1_MAPeriod; break;
         case 5: maperiod = M5_MAPeriod; break;
         case 15: maperiod = M15_MAPeriod; ma1period = 360; break;
         case 30: maperiod = M30_MAPeriod; ma1period = 180; break;
         case 60: maperiod = H1_MAPeriod; ma1period = 100; break;
         case 240: maperiod = H4_MAPeriod; ma1period = 180; break;
         case 1440: maperiod = D1_MAPeriod; ma1period = 5; break;
      }
   }
   else {
      maperiod = MAPeriod;
   }
  
   double MA0, MA_Cur, MA_Prev, MA_up0, MA_up1, MA_dn0, MA_dn1;
   int limit;
   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;

   for(int i=limit; i>=0; i--)
   {  
      MA0 = iMA(NULL,0,ma1period,0,MAMode,PRICE_CLOSE,i);
      MA_Cur = iMA(NULL,0,maperiod,0,MAMode,PRICE_CLOSE,i);
      MA_Prev = iMA(NULL,0,maperiod,0,MAMode,PRICE_CLOSE,i+1);
      MA_up0 = iEnvelopes(NULL, 0, maperiod, MAMode,0,PRICE_CLOSE,0.1,MODE_UPPER,i);
      MA_dn0 = iEnvelopes(NULL, 0, maperiod, MAMode,0,PRICE_CLOSE,0.1,MODE_LOWER,i);
      buy [i] = 0; sell [i] = 0;
      if ( Close[i] > MA_up0 )
      {
        MA_up1 = iEnvelopes(NULL, 0, maperiod, MAMode,0,PRICE_CLOSE,0.1,MODE_UPPER,i+1);
         if ( Close[i+1] < MA_up1 )
         {
            buy [i] = Low [i] - 4 * Point;
            if (Period () >= PERIOD_M5) buy [i] -= 6 * Point;
            if (Period () >= PERIOD_M15) buy [i] -= 6 * Point;
            if (Period () >= PERIOD_M30) buy [i] -= 6 * Point;
            if (Period () >= PERIOD_H1) buy [i] -= 6 * Point;
            if (Period () >= PERIOD_H4) buy [i] -= 6 * Point;
            if (Period () >= PERIOD_D1) buy [i] -= 6 * Point;
         }         
      }
       if ( Close[i] < MA_dn0 )
      {
       MA_dn1 = iEnvelopes(NULL, 0, maperiod, MAMode,0,PRICE_CLOSE,0.1,MODE_LOWER,i+1);
         if ( Close[i+1] > MA_dn1 )
         {
            sell [i] = High [i] + 4 * Point;
            if (Period () >= PERIOD_M5) sell [i] += 6 * Point;
            if (Period () >= PERIOD_M15) sell [i] += 6 * Point;
            if (Period () >= PERIOD_M30) sell [i] += 6 * Point;
            if (Period () >= PERIOD_H1) sell [i] += 6 * Point;
            if (Period () >= PERIOD_H4) sell [i] += 6 * Point;
            if (Period () >= PERIOD_D1) sell [i] += 6 * Point;
         }
      }
      
 
         
//========== COLOR CODING ===========================================               
        
       ExtMapBuffer3[i] = MA_Cur; //red 
       ExtMapBuffer2[i] = MA_Cur; //green
       ExtMapBuffer1[i] = MA_Cur; //yellow
       MA_up[i] = MA_up0;
       MA_dn[i] = MA_dn0;
       MA1[i] = MA0;
       
        if (MA_Prev > MA_Cur)
        {
        ExtMapBuffer2[i] = EMPTY_VALUE;
        
        }
       else if (MA_Prev < MA_Cur) 
        {
        ExtMapBuffer1[i] = EMPTY_VALUE; //-1 red/greem tight
        
        }
         else 
         {
         
         ExtMapBuffer1[i]=EMPTY_VALUE;//EMPTY_VALUE;
         ExtMapBuffer2[i]=EMPTY_VALUE;//EMPTY_VALUE;
         }        
      }

    return(0);
  }
//+------------------------------------------------------------------+

